/* FONTINST.CMD for compatibility fonts */

x = setlocal()

echo = '@'

i = 1
typ.i = CODEDFONTS;    typreq.i = NO; i = i + 1
typ.i = COMPAT240;     typreq.i = NO; i = i + 1
typ.i = COMPAT300;     typreq.i = NO; i = i + 1
typ.i = ALL;           typreq.i = NO
tottypes = i

source = '.'

ARG commandline

if WORDS(commandline) <> 0 then do
  if WORDS(commandline) < 2 then do
    targetdrv = WORD(commandline, 1)
    fontset.1 = ALL
    totfont = 1
  end
  else do
    if WORDS(commandline) < 7 then do
      targetdrv = WORD(commandline, 1)
      do i = 2 to WORDS(commandline)
        if WORDS(commandline) >= i then do
          j = i - 1
          fontset.j = WORD(commandline, i)
        end
      end
      totfont = WORDS(commandline) - 1
    end
    else do
      CALL HELP;
    end
  end
end
else do
  CALL HELP;
end

if POS(':', targetdrv) <> 2 then do
  CALL HELP;
end
drvlet = SUBSTR(targetdrv, 1, 1)
if POS(drvlet, 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz') = 0 then do
  CALL HELP;
end
if LENGTH(targetdrv) <> 2 then do
  CALL HELP;
end

targetdir = targetdrv || '\PSF2RES'

say '*********************************************************'
say '* Please make sure that you have enough hard drive space'
say '* available where PSF/2 fonts are being placed.'
say '* Press <enter> to continue or press <Ctl-C> to stop'
say '* installing the PSF/2 font options. After installation'
say '* starts you may have to press <Ctl-C> several times to'
say '* stop the installation.'
say '*********************************************************'
parse upper pull dummy

echo || 'md 'targetdir

if rc <> 0 then do
  call RxFuncAdd 'SysMkDir', 'RexxUtil', 'SysMkDir'
  ret_code = SysMkDir(targetdir)
  if ret_code <> 5 then do
    EXIT;
  end
end

do i = 1 to totfont
  matchfound = NO
  do j = 1 by 1 while SYMBOL('typ.j') = 'VAR'
    if fontset.i = typ.j then do
      matchfound = YES
      typreq.j = YES
      leave
    end
  end
  if matchfound = NO then do
    CALL HELP;
  end
end

say '*********************************************************'
say '* Putting PSF/2 2.00 font files in directory 'targetdir
say '* from the current directory.  If a directory already exists,'
say '* but the files do not exist, you will see error messages.'
say '* Please ignore the messages.  Press <Ctl-C> to stop.'
say '* You may need to press <Ctl-C> before installation stops.'
say '*********************************************************'

echo || 'md 'targetdir'\FONTC240'
echo || 'md 'targetdir'\FONTC300'
echo || 'md 'targetdir'\CODEFONT'
echo || 'md 'targetdir'\CODEPAGE'
echo || 'md 'targetdir'\CODEPAGE\PRIMARY'
echo || 'md 'targetdir'\CODEPAGE\SECONDRY'

echo || 'attrib -r 'targetdir'\*.* /s'
if rc <> 0 then do
  if rc <> 2 then do
    EXIT;
  end
end

font240d = NO
font300d = NO
codefontd = NO
codepaged = NO
do i = 1 to tottypes
  if typreq.i = YES then do
    select
      when typ.i = CODEDFONTS then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        codefontd = YES
      end
      when typ.i = COMPAT240 then do
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        codepaged = YES
      end
      when typ.i = COMPAT300 then do
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font300d = YES
        codepaged = YES
      end
      when typ.i = ALL then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        font300d = YES
        codefontd = YES
        codepaged = YES
      end
      otherwise
        say 'This program has a problem, please contact PSF/2 service.'
    end
  end
end

targetdrv
echo || 'cd 'targetdir

say '*********************************************************'
say '* Adding PSF/2 2.00 fonts to Resource Librarian.  Press'
say '* <Ctl-C> to stop.'
say '*********************************************************'

if font240d = YES then do
  echo || 'cd .\FONTC240'
  echo || 'RLADD R *.* * /R /L > ..\FONT240.LOG'
  echo || 'cd ..'
end

if font300d = YES then do
  echo || 'cd .\FONTC300'
  echo || 'RLADD R *.* * /R /L > ..\FONT300.LOG'
  echo || 'cd ..'
end

if codefontd = YES then do
  echo || 'cd .\CODEFONT'
  echo || 'RLADD R *.* * /R /L > ..\FONTCF.LOG'
  echo || 'cd ..'
end

if codepaged = YES then do
  echo || 'cd .\CODEPAGE\PRIMARY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTPRI.LOG'
  echo || 'cd ..\SECONDRY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTSEC.LOG'
  echo || 'cd ..\..'
end

say '*********************************************************'
say '* Fonts have been added, please examine '
say '* 'targetdir'\FONT*.LOG files for details.'
say '*********************************************************'

x = endlocal()
CALL QUIT;

HELP:;
  say '**************************************************************';
  say '* This install command must be executed from the directory   *';
  say '* where the PSF/2 install files are located.                 *';
  say '*                                                            *';
  say '* This install command requires one parameter.               *';
  say '*                                                            *';
  say '* The format is:                                             *';
  say '*   FONTINST <target drive> <fonts>                          *';
  say '*                                                            *';
  say '* where:                                                     *';
  say '*   <target drive> is the drive where PSF/2 is installed.    *';
  say '*     This is NOT the drive where PSF/2 files were           *';
  say '*     temporarily saved when you used the PUTDIR command.    *';
  say '*     This parameter is required.                            *';
  say '*   <fonts> is any or all of the following:                  *';
  say '*     ALL (default)                                          *';
  say '*     CODEDFONTS                                             *';
  say '*     COMPAT240                                              *';
  say '*     COMPAT300                                              *';
  say '* Example:                                                   *';
  say '*   fontinst c: all                                          *';
  say '*                                                            *';
  say '* Fonts are installed in the directory called \PSF2RES,      *';
  say '* any other fonts located in the font directories will be    *';
  say '* added to the Resource Librarian.                           *';
  say '**************************************************************';
  x = endlocal()
  CALL QUIT;
RETURN;

QUIT:;
EXIT;
